<?php
/*
Plugin Name: WP-Youdao-Slug
Plugin URI: http://www.youbaozang.com
Description: WP Youdao Slug 是一款自动把文章标题别名翻译为英文的插件，基于WP Slug Translate修改而来，由于国内网络特殊原因，因而采用有道词典作为翻译接口。如果翻译失败的话，他会使用文章ID作为别名保存。除了自动翻译文章别名，WP Youdao Slug还支持自动翻译该文章旗下的全部标签。如果翻译失败的话，他会使用标签URLEncode作为别名保存。
Version: 1.1
Author: 有宝藏
Author URI: http://www.youbaozang.com
Text Domain: WP-Youdao-Slug
Domain Path: /lang
*/

define("CLIENTID",get_option('wp_youdao_slug_keyfrom'));
define("CLIENTSECRET",get_option('wp_youdao_slug_apikey'));
define("TARGET","en");

function load_wp_youdao_slug_lang(){
	$currentLocale = get_locale();
	if(!empty($currentLocale)){
		$moFile = dirname(__FILE__) . "/lang/wp-youdao-slug-" . $currentLocale . ".mo";
		if(@file_exists($moFile) && is_readable($moFile)) load_textdomain('WP-Slug-Translate',$moFile);
	}
}
add_filter('init','load_wp_youdao_slug_lang');

class WstHttpRequest
{
	function curlRequest($url, $header = array(), $postData = ''){
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		if(!empty($header)){
			curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
		}
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		if(!empty($postData)){
			curl_setopt($ch, CURLOPT_POST, TRUE);
			curl_setopt($ch, CURLOPT_POSTFIELDS, is_array($postData) ? http_build_query($postData) : $postData);
		}
		$curlResponse = curl_exec($ch);
		curl_close($ch);
		return $curlResponse;
	}
}

class WstMicrosoftTranslator extends WstHttpRequest
{
	private $_clientID = CLIENTID;
	private $_clientSecret = CLIENTSECRET;
	private $_fromLanguage = SOURCE;
	private $_toLanguage = TARGET;

	private $_grantType = "client_credentials";
	private $_scopeUrl = "http://api.microsofttranslator.com";
	private $_authUrl = "https://datamarket.accesscontrol.windows.net/v2/OAuth2-13/";

	private function _getTokens(){
		try{
			$header = array('User-Agent: Mozilla/5.0 (Windows NT 5.1; rv:6.0.1) Gecko/20100101 Firefox/6.0.1');
			$postData = array(
				'grant_type' => $this->_grantType,
				'scope' => $this->_scopeUrl,
				'client_id' => $this->_clientID,
				'client_secret' => $this->_clientSecret
			);
			$response = $this->curlRequest($this->_authUrl, $header, $postData);
			$jsonObj = json_decode($response);
			if(!empty($jsonObj->access_token)){
				return $jsonObj->access_token;
			}
		}
		catch(Exception $e){
			//echo "Exception-" . $e->getMessage();
		}
	}

	function ms_translate($inputStr){
		$params = "text=" . rawurlencode($inputStr) . "&from=" . $this->_fromLanguage . "&to=" . $this->_toLanguage;
		$translateUrl = "http://api.microsofttranslator.com/v2/Http.svc/Translate?$params";
		//$accessToken = $this->_getTokens();
		//$authHeader = "Authorization: Bearer " . $accessToken;
		//$header = array($authHeader, "Content-Type: text/xml");
		$curlResponse = $this->curlRequest($translateUrl, $header);
		
		$xmlObj = simplexml_load_string($curlResponse);
		$translatedStr = '';
		foreach((array)$xmlObj[0] as $val){
			$translatedStr = $val;
		}

		return $translatedStr;
	}
	
	function translate($inputStr) {
		try {
			$keywords = $inputStr; //mb_convert_encoding($inputStr, 'UTF-8', 'GBK'); //gbk 一定要转成 utf-8
			//echo $keywords.'<br>';
			
			$keywords = urlencode($keywords); //必须做 url 编码
			$youdaourl ='http://fanyi.youdao.com/openapi.do?keyfrom='.$this->_clientID.'&key='.$this->_clientSecret.'&type=data&doctype=json&version=1.1&q='.$keywords;
			
			//返回类型 设为 json，这样处理起来方便些
			$response = @file_get_contents($youdaourl); //file_get_contents前面加上@符号就可以不报错了
			$jsonresult = json_decode($response,1);
			$translation = $jsonresult['translation'][0];
			
			$str = preg_replace('/[^a-z0-9- ]/i', '', $translation);
			//echo $str.'<br>';
			$str = str_replace(' ', '-', strtolower(trim($str)));
			//echo $str.'<br>';
			$result = $str;
			//echo $result.'<br>';
		
			return $result;
		}
		catch(Exception $e){
			//echo "Exception-" . $e->getMessage();
			return '';
		}
	}

}

if(get_option("wp_youdao_slug_secondmode")!='yes'){

function wp_youdao_slug($postid){
	global $wpdb;
	$sql = "SELECT post_title,post_name FROM $wpdb->posts WHERE ID = '$postid'";
	$results = $wpdb->get_results($sql);
	
	$post_title = $results[0]->post_title;
	$post_name = $results[0]->post_name;
	
	$sql_tag = "SELECT name,slug FROM $wpdb->terms WHERE term_id IN (SELECT term_id FROM $wpdb->term_taxonomy WHERE term_taxonomy_id IN (SELECT term_taxonomy_id FROM $wpdb->term_relationships where object_id='$postid') AND taxonomy IN ('post_tag','offers-tag','strategy-tag','show-tag','overseas-tag'))";
	$results_tags = $wpdb->get_results($sql_tag);
	
	$flag_count_post = 0;
	$flag_count_tag = 0;
	
	if( !substr_count($post_name,'%') && !is_numeric($post_name) ){
		if(substr_count($post_name,'_')){
			$wst_post_name = str_replace('_','-',$post_name);
			$sql = "UPDATE $wpdb->posts SET post_name = '$wst_post_name' WHERE ID = '$postid'";
			$wpdb->query($sql);
		}
		$flag_count_post = $flag_count_post + 1;
	}
	
	if($flag_count_post != 1) {
		$post_title = str_replace(array('_','/'),array(' ',' '),$post_title);
		$wst_microsoft= new WstMicrosoftTranslator();
		$wst_title = sanitize_title( $wst_microsoft->translate($post_title) );
		if( strlen($wst_title) < 2 ){
			$wst_title = $postid;
		}
			
		$sql = "UPDATE $wpdb->posts SET post_name = '$wst_title' WHERE ID = '$postid'";		
		$wpdb->query($sql);
	}

	foreach ($results_tags as $tag) {
		if( !substr_count($tag->slug,'%') && !is_numeric($tag->slug) ){
			if(substr_count($tag->slug,'_')){
				$wst_slug = str_replace('_','-',$tag->slug);
				$sql_tag = "UPDATE $wpdb->terms SET slug = '$wst_slug' WHERE term_id IN (SELECT term_id FROM $wpdb->term_taxonomy WHERE term_taxonomy_id IN (SELECT term_taxonomy_id FROM $wpdb->term_relationships where object_id='$postid') AND taxonomy IN ('post_tag','offers-tag','strategy-tag','show-tag','overseas-tag')) AND name='$tag_oldname'";
				$wpdb->query($sql_tag);
			}
			$flag_count_tag = $flag_count_tag + 1;
		}
	}

	if($flag_count_tag != count($flag_count_tag)) {
		foreach ($results_tags as $tag) {
			$tag_oldname = $tag->name;
			$tag->name = str_replace(array('_','/'),array(' ',' '),$tag->name);
			$wst_microsoft= new WstMicrosoftTranslator();
			$wst_slug = sanitize_title( $wst_microsoft->translate($tag->name) );
			if( strlen($wst_slug) < 2 ){
				$wst_slug = urlencode($tag_oldname);
			}
			//echo $wst_slug;
			$sql_tag = "UPDATE $wpdb->terms SET slug = '$wst_slug' WHERE term_id IN (SELECT term_id FROM $wpdb->term_taxonomy WHERE term_taxonomy_id IN (SELECT term_taxonomy_id FROM $wpdb->term_relationships where object_id='$postid') AND taxonomy IN ('post_tag','offers-tag','strategy-tag','show-tag','overseas-tag')) AND name='$tag_oldname'";
			$wpdb->query($sql_tag);
		}
	}

}

//add_action('publish_post', 'wp_youdao_slug', 1);
//add_action('edit_post', 'wp_youdao_slug', 1);
add_action('save_post', 'wp_youdao_slug', 1);

}else{

function wp_youdao_slug($postname){
	$post_name = $postname;
	$post_title = $_POST['post_title'];
	
	if( !empty($post_name) && !is_numeric($post_name) ) return str_replace('_','-',$post_name);

	$post_title = str_replace(array('_','/'),array(' ',' '),$post_title);
	$wst_microsoft= new WstMicrosoftTranslator();
	$wst_title = sanitize_title( $wst_microsoft->translate($post_title) );
	
	return $wst_title;
}
add_filter('name_save_pre', 'wp_youdao_slug', 1);

}

function wp_youdao_slug_activate(){
	add_option('wp_youdao_slug_keyfrom','publickey');
	add_option('wp_youdao_slug_apikey','1446930262');
	add_option('wp_youdao_slug_secondmode','');
	add_option('wp_youdao_slug_deactivate','');
}
register_activation_hook( __FILE__, 'wp_youdao_slug_activate' );

if(get_option("wp_youdao_slug_deactivate")=='yes'){
	function wp_youdao_slug_deactivate(){
		delete_option('wp_youdao_slug_keyfrom');
		delete_option('wp_youdao_slug_apikey');
		delete_option('wp_youdao_slug_secondmode');
		delete_option('wp_youdao_slug_deactivate');
	}
	register_deactivation_hook( __FILE__, 'wp_youdao_slug_deactivate' );
}

function wp_youdao_slug_settings_link($action_links,$plugin_file){
	if($plugin_file==plugin_basename(__FILE__)){
		$wst_settings_link = '<a href="options-general.php?page=' . dirname(plugin_basename(__FILE__)) . '/wp_youdao_slug_admin.php">' . __("Settings") . '</a>';
		array_unshift($action_links,$wst_settings_link);
	}
	return $action_links;
}
add_filter('plugin_action_links','wp_youdao_slug_settings_link',10,2); 

if(is_admin()){require_once('wp_youdao_slug_admin.php');}

?>